import numpy as np

def load_data():
    """ Load training dataset

        Returns tuple of length 4: (X_train, y_train, X_val, y_val)
        where X_train is an N_train-x-M ndarray and y_train is an N_train-x-1 ndarray and
        where X_val is an N_val-x-M ndarray and y_val is an N_val-x-1 ndarray.
    """
    X = np.load('data/regression_train_input.npy')
    y = np.load('data/regression_train_output.npy')

    N = len(y)
    N_val = 10
    N_train = N - N_val    

    X_train = X[:N_train]
    y_train = y[:N_train]
    X_val = X[N_train:]
    y_val = y[N_train:]

    return (X_train, y_train, X_val, y_val)


def kernel_boxcar(x, z, h):
    """ Return the result of applying the boxcar kernel on the two input vectors.

        x: Mx1 numpy ndarray
        z: Mx1 numpy ndarray
        
        Returns: float value after appying kernel to x and z
    """
    ### YOUR CODE HERE


def kernel_rbf(x, z, h):
    """ Return the result of applying the radial basis function kernel 
        on the two input vectors, given the hyperparameter h.

        x: Mx1 numpy ndarray
        z: Mx1 numpy ndarray
        gamma: float value of hyperparameter
        
        Returns: float value after appying kernel to x and z
    """
    ### YOUR CODE HERE

    
def predict_kernel_regression(X, X_train, y_train, kernel_function, h=0.5):
    """ Predict the output values y for the given input design matrix X.

        X: Input matrix in NxM numpy ndarray, where we want to predict the output
            for the vector in each row of X.
        X_train: Design matrix of training input in N_train-x-M numpy ndarray
        y_train: Training output in N_train-x-1 numpy array
        kernel_function: Function that takes two arguments that are each
            Mx1 numpy ndarrays and returns a float value.
        lamb: float value of regularization hyperparameter, lambda (Note, this is a 
            different hyperparameter than the hyperparameter used in RBF kernels)

        Returns: Nx1 numpy ndarray, where the i-th entry is the predicted value 
            corresponding the i-th row vector in X
    """
    ### YOUR CODE HERE


def mse(y, y_hat):
    err = y - y_hat
    sqerr = err**2
    return np.mean(sqerr)

